/** -------------------------------------------------------------------
  *      maintainer: Marcus Wolschon <Suran@gmx.net>
  * -------------------------------------------------------------------
  * projects:
  *	- Jaugment II
  *       part: twiddler-help-sheet
  *	   used in release: current      used in version: current
  * -------------------------------------------------------------------
  * Copyright:   Copyright (c) 2000 by Marcus Wolschon <Suran@gmx.net>
  * -------------------------------------------------------------------
  * changes:
  * 0.0.1 (2001-09-02, Marcus Wolschon<Suran@gmx.net>)
  *       - created
  *       - it works
  * 0.0.2 (2001-09-06, Marcus Wolschon<Suran@gmx.net>)
  *       - has the same size as the image
  *       - deliveres key-events if possible
  * -------------------------------------------------------------------
  * TODO:
  */
package jaugment2.twiddlerhelpsheet;

import java.awt.event.*;
import jaugment2.helpers.Logger;

/**
 * Title:        Twiddler-HelpSheet
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author Marcus Wolschon Suran@gmx.net
 * @version 1.0
 */

public class HelpSheet extends javax.swing.JFrame
{

  public HelpSheet()
  {
    try
    {
      jbInit();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
  }

  public HelpSheet(java.awt.Component c)
  {
    try
    {
     this.textComponent = c;
     jbInit();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
  }


  private void jbInit() throws Exception
  {
    this.addMouseListener(new java.awt.event.MouseAdapter()
    {
      public void mouseClicked(MouseEvent e)
      {
        this_mouseClicked(e);
      }
    });


   setDefaultCloseOperation(javax.swing.JFrame.HIDE_ON_CLOSE);


   bg = loadImage("sheet.gif");

   Logger.debug.println("DEBUG[HelpSheet]: getting width");

   bg.getWidth(new java.awt.image.ImageObserver()
                                   {
                                    private boolean w = false;
                                    private boolean h = false;
                                        public boolean imageUpdate(java.awt.Image img, int infoflags,
	   		       int x, int y, int width, int height)
                                      {
                                       if(!w)
                                          {
                                           w = (infoflags & java.awt.image.ImageObserver.WIDTH) != 0;
                                           if(w)
                                             ws = width;
                                          }
                                       if(!h)
                                          {h = (infoflags & java.awt.image.ImageObserver.HEIGHT) != 0;
                                           if(h)
                                             hs = height;
                                          }
                                       if(!imgLoaded)
                                          Logger.debug.println("DEBUG[HelpSheet]: imageUpdate width="+width+" infoflags"+infoflags);
                                       if(w && h)
                                        {

                                         imgLoaded = true;
                                        };
                                       return(true);}
                                   });
   while(!imgLoaded)
     Thread.currentThread().yield();
   Logger.debug.println("DEBUG[HelpSheet]: setting width ws="+ws+" hs="+hs);
   this.setSize(ws, hs);
    this.addKeyListener(new java.awt.event.KeyAdapter()
    {
      public void keyPressed(KeyEvent e)
      {
        this_keyPressed(e);
      }
      public void keyReleased(KeyEvent e)
      {
        this_keyReleased(e);
      }
      public void keyTyped(KeyEvent e)
      {
        this_keyTyped(e);
      }
    });
    this.addFocusListener(new java.awt.event.FocusAdapter()
    {
      public void focusGained(FocusEvent e)
      {
        this_focusGained(e);
      }
    });

   this.pack();

   this.requestFocus();
   javax.swing.SwingUtilities.invokeLater(new Runnable()
           {public void run(){HelpSheet.this.requestFocus();}}
                                          );
  }

  boolean imgLoaded = false;
  int ws = 0;
  int hs = 0;
  java.awt.Component textComponent = null;

  private java.awt.Image bg = null;

    public java.awt.Image loadImage(final String resourceName) {
	try {
	    final Class c = getClass();
	    java.awt.image.ImageProducer ip = (java.awt.image.ImageProducer)
		java.security.AccessController.doPrivileged(
		new java.security.PrivilegedAction() {
		    public Object run() {
			java.net.URL url;
			if ((url = c.getResource(resourceName)) == null) {
			    return null;
			} else {
			    try {
				return url.getContent();
			    } catch (java.io.IOException ioe) {
				return null;
			    }
			}
		    }
	    });

	    if (ip == null)
		return null;
	    java.awt.Toolkit tk = java.awt.Toolkit.getDefaultToolkit();
	    return tk.createImage(ip);
	} catch (Exception ex) {
	    return null;
	}
    }

  void this_mouseClicked(MouseEvent e)
  {
   this.hide();
  }


  public void paint(java.awt.Graphics g)
  {
   if(this.getWidth() != ws)
      this.setSize(ws, hs);
     try
       {
        g.drawImage(bg,0,0, new java.awt.image.ImageObserver()
                                   {
                                        public boolean imageUpdate(java.awt.Image img, int infoflags,
	   		       int x, int y, int width, int height)
                                      {return(true);}
                                   }
                   );
       }
     catch(Exception e)
       {
        e.printStackTrace(Logger.err);
        // ignore this error
       }
  }

  void this_focusGained(FocusEvent e)
  {
   if(e.getComponent() != this)
     {
      Logger.debug.println("DEBUG[HelpSheet]: got focus from a ["+e.getComponent().getClass().getName()+"]");
      textComponent = e.getComponent();
     }
  }

  void this_keyPressed(KeyEvent e)
  {
   Logger.debug.println("DEBUG[HelpSheet]: this_keyPressed textComponent="+(textComponent==null?"null":textComponent.getClass().getName()));
   if(textComponent != null)
     textComponent.dispatchEvent(e);
  }

  void this_keyReleased(KeyEvent e)
  {
   if(textComponent != null)
     textComponent.dispatchEvent(e);
  }

  void this_keyTyped(KeyEvent e)
  {
   if(textComponent != null)
     textComponent.dispatchEvent(e);
  }
}