/** -------------------------------------------------------------------
  *      maintainer: Marcus Wolschon <Suran@gmx.net>
  * -------------------------------------------------------------------
  * projects:
  *	- Jaugment II
  *       part: twiddler-help-sheet
  *	   used in release: current      used in version: current
  * -------------------------------------------------------------------
  * Copyright:   Copyright (c) 2000 by Marcus Wolschon <Suran@gmx.net>
  * -------------------------------------------------------------------
  * changes:
  * 0.0.1 (2001-09-02, Marcus Wolschon<Suran@gmx.net>)
  *       - created
  * -------------------------------------------------------------------
  * TODO:
  *       - integrate it into all text-input-fields automagically
  */
package jaugment2.twiddlerhelpsheet;

  //JDK
//import java.rmi.server.UnicastRemoteObject;
import java.rmi.RemoteException;
  //serviceui-draft-standart
import net.jini.lookup.entry.UIDescriptor;
  //project
import jaugment2.jini.simpleService.VerySimpleService;
import jaugment2.helpers.Logger;



//helper-mark for configure to determine that rmic needs to be executed for this file
//rmimakehelper


/**
 * Title:        Twiddler-HelpSheet
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author Marcus Wolschon Suran@gmx.net
 * @version 1.0
 */

public class TwiddlerHelpSheetService extends VerySimpleService implements TwiddlerHelpSheetProxyIF
{
 private static final boolean debugThis = true;

  public TwiddlerHelpSheetService() throws java.rmi.RemoteException , java.io.IOException
  {
   if(debugThis)Logger.debug.println("DEBUG: TwiddlerHelpSheetService starting up...");
//   landLord = new SimpleLandlord(simpleLeaselistener);
   init(this, jaugment2.twiddlerhelpsheet.TwiddlerHelpSheetProxyIF.class);
  }


  public String getComment()
  {return("provides a help-sheet for new twiddler-users");};
  public String getCreator()
  {return("Marcus Wolschon <Suran@gmx.net>");};
  public UIDescriptor getUIDescriptor()
  {
   if(debugThis)Logger.debug.println("DEBUG: TwiddlerHelpSheetService.getUIDescriptor() called...");
   return(TwiddlerHelpSheetSwingRepresentation.getUIDescriptor());
  };


}